REM MissingDependencies.vbs
REM
REM This script shows a message box to a Windows user 
REM who has tried to start Enchanting but does not
REM have all dependencies installed on their computer.
REM
REM It offers to take them to instructions to fix the problem.

Set wshShell = CreateObject("WScript.Shell")

JDK = wshShell.ExpandEnvironmentStrings("%JAVA_HOME%")
HasJDK = JDK <> "%JAVA_HOME%"

NXTDriver = wshShell.ExpandEnvironmentStrings("%FANTOM_HOME%")
HasNXTDriver = NXTDriver <> "%FANTOM_HOME%"


title = "Enchanting is unable to start"
style = 4 + 48  Rem  YesNo buttons and Exclamation mark
msg = ""
url = ""

if HasJDK then
	if HasNXTDriver then
		msg = "You have all prerequisites installed.  This message should never come up."  
		url = "http://enchanting.robotclub.ab.ca/Inexplicable+Startup+Error+On+Windows"
	else
		msg = "You need to install LEGO's NXT driver before you can run Enchanting."
		url = "http://enchanting.robotclub.ab.ca/Install+NXT+Driver+On+Windows"
	end if
else
	if HasNXTDriver then
		msg = "You need to install Oracle's 32-bit Java Development Kit (JDK),"
		msg = msg & vbCrLF & "version 1.5 or newer, before Enchanting can run." 
		url = "http://enchanting.robotclub.ab.ca/Install+JDK+On+Windows"
	else
		msg = "You need to install the following for Enchanting to work:"
		msg = msg & vbCrLF & " - Oracle's JDK, version 1.5 or newer, 32-bit"
		msg = msg & vbCrLF & " - LEGO's Mindstorms NXT driver"
		url = "http://enchanting.robotclub.ab.ca/Install+JDK+and+NXT+Driver+On+Windows"
	end if
end if

msg = msg & vbCrLF & vbCrLF & "Would you like instructions on how to fix the problem?"

result = MsgBox(msg, style, title)

if result = 6 then 	
	rem User pressed Yes
	wshShell.Run(url)
else
	REM MsgBox "Enchanting will now quit."
end if
