ScratchListMorph subclass: #BYOBListWatcherMorph
	instanceVariableNames: 'list lastUpdated isUpdating '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!BYOBListWatcherMorph methodsFor: 'accessing' stamp: 'jens 7/13/2010 12:48'!
list
	^ list! !

!BYOBListWatcherMorph methodsFor: 'accessing' stamp: 'jens 7/13/2010 19:42'!
list: aBYOBList

	list _ aBYOBList.
	self update
! !


!BYOBListWatcherMorph methodsFor: 'initialization' stamp: 'jens 7/14/2010 00:39'!
initialize
	super initialize.
	list _ BYOBList new.
	lastUpdated _ list lastChanged.
	isUpdating _ false! !


!BYOBListWatcherMorph methodsFor: 'dropping/grabbing' stamp: 'jens 7/13/2010 13:00'!
justDroppedInto: aMorph event: evt

	(aMorph isKindOf: ScratchStageMorph) ifTrue: [
		super justDroppedInto: aMorph event: evt.
		self world ifNotNil: [self world startSteppingSubmorphsOf: self].
		^ self].

	"delete me if dropped anywhere but the stage"

"
	self position:  evt hand formerPosition.
	^ self delete

"! !


!BYOBListWatcherMorph methodsFor: 'updating' stamp: 'jens 7/15/2010 23:28'!
scrollActiveCellIntoView

	"override my superclass behavior - do nothing"! !

!BYOBListWatcherMorph methodsFor: 'updating' stamp: 'jens 7/15/2010 23:32'!
update

	isUpdating ifTrue: [^ self].
	isUpdating _ true.
	self clear.
	1 to: list size do: [:i |
		self privateInsertLine: (list at: i) at: i].
	self layoutChanged.
	lastUpdated _ list lastChanged.
	isUpdating _ false.
		! !

!BYOBListWatcherMorph methodsFor: 'updating' stamp: 'jens 7/15/2010 22:28'!
updateList
	list contents: self asArray asOrderedCollection.
	lastUpdated _ list lastChanged! !


!BYOBListWatcherMorph methodsFor: 'private' stamp: 'jens 7/16/2010 00:17'!
createCell: anObject

	| readout cell font numberRight txt|

	txt _ anObject.
	(anObject isKindOf: String)
		ifFalse: [txt _ anObject printString].

	font _ ScratchFrameMorph getFont: #Watcher.
	readout _ ListMultilineStringMorph new
		borderWidth: 0;
		color: Color transparent;
		textColor: Color white;
		growWithText: true;
		contents: txt font: font.
	readout height: ((ScratchTranslator stringExtent: 'A' font: font) y) + 6.
	ScratchTranslator isRTL
		ifTrue: [numberRight _ self right - 5]
		ifFalse: [numberRight _ self left + self largestIndexWidth + 6].
	ScratchTranslator isRTL
		ifTrue: [readout width: self right - self left - self largestIndexWidth - 33]
		ifFalse: [readout width: self right - numberRight - 25].

	cell _ WatcherReadoutFrameMorph new
		color: ScriptableScratchMorph listBlockColor;
		extent: readout extent + 3;
		addMorphBack: readout.

	(anObject isKindOf: String) ifFalse: [
		cell complexObject: anObject ].

	cell position: scrollPane contents bottomLeft.

	"avoid recursive lists"
	scrollPane contents allMorphs detect: [:m | cell allMorphs includes: m] ifNone: [
		scrollPane contents addMorph: cell].

	^ cell
! !

!BYOBListWatcherMorph methodsFor: 'private' stamp: 'jens 7/16/2010 00:44'!
noteChangeAtIndex: index

	self updateContents

! !

!BYOBListWatcherMorph methodsFor: 'private' stamp: 'jens 7/16/2010 00:37'!
privateInsertLine: anObject at: aNumber

	| index newCell |

"
	(anObject isKindOf: list class) ifTrue: [
		(anObject containsRecursive: list) ifTrue: [
			self error: 'attempting to create a recursive list']].
"

	index _ aNumber asInteger.
	(index > 0 and: [index <= (cellMorphs size + 1)]) ifFalse: [
		lastActivityError _ true.
		^ self].

	newCell _ self createCell: anObject.
	index = 1
		ifTrue: [cellMorphs addFirst: newCell]
		ifFalse: [
			index > cellMorphs size
				ifTrue: [cellMorphs addLast: newCell]
				ifFalse: [cellMorphs add: newCell afterIndex: index - 1]].

	self updateCountMorph.

	self updateContents.

"	self noteChangeAtIndex: index."
	^ newCell
! !


!BYOBListWatcherMorph methodsFor: 'stepping' stamp: 'jens 7/15/2010 23:43'!
step

	lastUpdated = list lastChanged
		ifTrue: [^ self].

	self update.
	super step! !


!BYOBListWatcherMorph methodsFor: 'user interaction' stamp: 'jens 7/15/2010 22:37'!
deleteLineAt: aNumber

	super deleteLineAt: aNumber	.
	list deleteLineAt: aNumber.
	lastUpdated _ list lastChanged! !

!BYOBListWatcherMorph methodsFor: 'user interaction' stamp: 'jens 7/15/2010 22:57'!
focusCell: cellMorph

	super focusCell: cellMorph.
	lastUpdated _ list lastChanged.
! !

!BYOBListWatcherMorph methodsFor: 'user interaction' stamp: 'jens 7/15/2010 23:21'!
focusIndex: anInteger

	super focusIndex: anInteger.
	lastUpdated _ list lastChanged.
	lastActivityIndex _ anInteger
! !

!BYOBListWatcherMorph methodsFor: 'user interaction' stamp: 'jens 7/15/2010 22:44'!
insertLine: aString at: aNumber

	| newCell |
	newCell _ super insertLine: aString at: aNumber.
	list insertLine: aString at: aNumber.
	lastUpdated _ list lastChanged.
	^ newCell
! !

!BYOBListWatcherMorph methodsFor: 'user interaction' stamp: 'jens 7/15/2010 22:38'!
setLineAt: aNumber to: newContents

	super setLineAt: aNumber to: newContents.
	list setLineAt: aNumber to: newContents.
	lastUpdated _ list lastChanged

! !


!BYOBListWatcherMorph methodsFor: 'comparing' stamp: 'jens 7/15/2010 21:27'!
= another

	^ self == another! !


!BYOBListWatcherMorph methodsFor: 'event handling' stamp: 'jens 7/16/2010 00:36'!
mouseDown: evt
	"Handle a mouse click. Left button either drags or performs click action. Right button brings up a menu."

	| p listOwner |

	resizeOffset _ nil.
	evt hand toolType = 'CutTool' ifTrue: [
		evt shiftPressed ifFalse: [evt hand toolType: nil].
		^ self delete].

	World activeHand showTemporaryCursor: nil.
	evt hand newKeyboardFocus: nil.
	p _ evt cursorPoint.

	((addItemMorph bounds expandBy: 2) containsPoint: p) ifTrue: [
		^ self insertLine: '' at: (self lineCount + 1)].

	((addSublistMorph bounds expandBy: 2) containsPoint: p) ifTrue: [
		^ list insertLine: BYOBList new at: (self lineCount + 1)].

	listOwner _ self listOwner.
	(((deleteMorph bounds expandBy: 2) containsPoint: p) and: [listOwner notNil]) ifTrue: [
		^ listOwner list deleteLineAt: (listOwner indexOf: self list)].

	evt rightButtonPressed
		ifTrue: [Sensor waitNoButton. ^ self rightButtonMenu]
		ifFalse:	[
			((resizeMorph bounds expandBy: 4) containsPoint: p)
				ifFalse: [evt hand grabMorph: self]
				ifTrue: [resizeOffset _ self bottomRight - p]].
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BYOBListWatcherMorph class
	instanceVariableNames: ''!

!BYOBListWatcherMorph class methodsFor: 'instance creation' stamp: 'jens 7/13/2010 12:49'!
on: aBYOBList

	^ self new list: aBYOBList! !
