ScrollPane subclass: #PluggableTextMorph
	instanceVariableNames: 'textMorph getTextSelector setTextSelector getSelectionSelector hasUnacceptedEdits askBeforeDiscardingEdits selectionInterval hasEditingConflicts '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!PluggableTextMorph methodsFor: 'initialization' stamp: 'di 9/11/1998 15:46'!
acceptOnCR: trueOrFalse
	textMorph acceptOnCR: trueOrFalse! !

!PluggableTextMorph methodsFor: 'initialization' stamp: 'di 5/4/1998 15:55'!
editString: aString 
	"Jam some text in.  This is treated as clean text by default."

	self setText: aString asText! !

!PluggableTextMorph methodsFor: 'initialization' stamp: 'dew 2/21/1999 03:07'!
extent: newExtent
	super extent: (newExtent max: 36@16).
	textMorph ifNotNil:
		[textMorph extent: (self innerBounds width-6)@self height].
	self setScrollDeltas! !

!PluggableTextMorph methodsFor: 'initialization' stamp: 'bolot 11/2/1999 03:18'!
font: aFont
	textMorph beAllFont: aFont! !

!PluggableTextMorph methodsFor: 'initialization' stamp: 'jm 11/24/2002 10:25'!
initialize

	super initialize.
	color _ Color white.
	hasUnacceptedEdits _ false.
	hasEditingConflicts _ false.
	askBeforeDiscardingEdits _ true! !

!PluggableTextMorph methodsFor: 'initialization' stamp: 'jm 6/13/2007 22:04'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel

	self model: anObject.
	getTextSelector _ getTextSel.
	setTextSelector _ setTextSel.
	getSelectionSelector _ getSelectionSel.
	getMenuSelector _ getMenuSel.
	self borderWidth: 1.
	self setText: self getText.
	self setSelection: self getSelection.
	self font: TextStyle defaultFont.
! !


!PluggableTextMorph methodsFor: 'model access' stamp: 'di 4/7/98 16:15'!
getSelection
	"Answer the model's selection interval."

	getSelectionSelector == nil ifTrue: [^ 1 to: 0].  "null selection"
	^ model perform: getSelectionSelector
! !

!PluggableTextMorph methodsFor: 'model access' stamp: 'di 1/29/2000 14:34'!
getText 
	"Retrieve the current model text"

	| newText |
	getTextSelector == nil ifTrue: [^ Text new].
	newText _ model perform: getTextSelector.
	newText ifNil: [^Text new].
	^ newText shallowCopy! !

!PluggableTextMorph methodsFor: 'model access' stamp: 'di 6/22/1998 01:32'!
selectionInterval: sel
	selectionInterval _ sel! !

!PluggableTextMorph methodsFor: 'model access' stamp: 'jm 11/14/2003 10:17'!
setSelection: sel

	| editor |
	selectionInterval _ sel.
	(editor _ textMorph editor) ifNotNil: [editor selectFrom: sel first to: sel last].
	self scrollSelectionIntoView ifFalse: [scroller changed].! !

!PluggableTextMorph methodsFor: 'model access' stamp: 'ls 7/20/1998 22:50'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph _ TextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!PluggableTextMorph methodsFor: 'model access' stamp: 'di 4/20/1998 07:59'!
text
	^ textMorph contents! !


!PluggableTextMorph methodsFor: 'menu commands' stamp: 'sw 10/14/1999 07:42'!
accept
	"Inform the model of text to be accepted, and return true if OK."
	| textToAccept ok |
	self canDiscardEdits ifTrue: [^ self flash].
	self hasEditingConflicts ifTrue:
		[(self confirm: 'Caution!! This method has been changed elsewhere
since you started editing it here.  Accept anyway?') ifFalse: [^ self flash]].
	textToAccept _ textMorph asText.
	ok _ (setTextSelector == nil) or:
		[setTextSelector numArgs = 2
			ifTrue: [model perform: setTextSelector with: textToAccept with: self]
			ifFalse: [model perform: setTextSelector with: textToAccept]].
	ok ifTrue:
		[self setText: self getText.
		self hasUnacceptedEdits: false]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:41'!
again
	self handleEdit: [textMorph editor again]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:43'!
browseIt
	textMorph editor browseIt! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 4/22/1998 11:04'!
cancel
	self setText: self getText.
	self setSelection: self getSelection.! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:41'!
changeStyle
	self handleEdit: [textMorph editor changeStyle]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'sw 9/27/1999 11:57'!
chooseAlignment
	self handleEdit: [textMorph editor changeAlignment]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 4/11/98 16:33'!
copySelection
	textMorph editor copySelection! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:41'!
cut
	self handleEdit: [textMorph editor cut]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 22:04'!
doIt
	self handleEdit: [textMorph editor evaluateSelection]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'jens 6/5/2009 00:06'!
elementFromSelection
	self handleEdit: [textMorph editor elementFromSelection]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:41'!
explain
	self handleEdit: [textMorph editor explain]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:02'!
fileItIn
	self handleEdit: [textMorph editor fileItIn]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:42'!
find
	self handleEdit: [textMorph editor find]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:42'!
findAgain
	self handleEdit: [textMorph editor findAgain]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:02'!
implementorsOfIt
	self handleEdit: [textMorph editor implementorsOfIt]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'jens 5/21/2010 02:20'!
inspectIt
	| result |

	Preferences userMode ifTrue: [^ #failedDoit].

	self handleEdit:
		[result _ textMorph editor evaluateSelection.
		((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [self flash]
			ifFalse: [result inspect]]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:01'!
methodNamesContainingIt
	self handleEdit: [textMorph editor methodNamesContainingIt]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:01'!
methodSourceContainingIt
	self handleEdit: [textMorph editor methodSourceContainingIt]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:01'!
methodStringsContainingit
	self handleEdit: [textMorph editor methodStringsContainingit]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:44'!
offerFontMenu
	self handleEdit: [textMorph editor offerFontMenu]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:44'!
paste
	self handleEdit: [textMorph editor paste]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 4/26/2000 22:22'!
pasteRecent
	"Paste an item chosen from RecentClippings."

	| clipping |
	(clipping _ ParagraphEditor chooseRecentClipping) ifNil: [^ self].
	ParagraphEditor clipboardTextPut: clipping.
	^ self handleEdit: [textMorph editor paste]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'sw 11/7/1999 00:01'!
prettyPrint
	self handleEdit: [textMorph editor prettyPrint]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'RAA 6/13/2000 10:55'!
printIt
	| result oldEditor |

	textMorph editor selectFrom: selectionInterval first to: selectionInterval last;
						model: model.  "For, eg, evaluateSelection"
	textMorph handleEdit: [result _ (oldEditor _ textMorph editor) evaluateSelection].
	((result isKindOf: FakeClassPool) or: [result == #failedDoit]) ifTrue: [^self flash].
	selectionInterval _ oldEditor selectionInterval.
	textMorph installEditorToReplace: oldEditor.
	textMorph handleEdit: [oldEditor afterSelectionInsertAndSelect: result printString].
	selectionInterval _ oldEditor selectionInterval.
	
	textMorph editor selectFrom: selectionInterval first to: selectionInterval last.
	self scrollSelectionIntoView.

! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 15:59'!
referencesToIt
	self handleEdit: [textMorph editor referencesToIt]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'dew 3/7/2000 21:15'!
saveContentsInFile
	self handleEdit: [textMorph editor saveContentsInFile]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'jm 12/7/2005 16:37'!
scrollBarMenuButtonPressed: evt

	| menu |
	(menu _ self getMenu: evt shiftPressed) ifNotNil: [
		"Set up to use perform:orSendTo: for model/view dispatch"
		menu setInvokingView: self.
		menu popUpForHand: evt hand].
! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 15:31'!
sendersOfIt
	self handleEdit: [textMorph editor sendersOfIt]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 4/11/98 16:32'!
setSearchString
	textMorph editor setSearchString! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/20/1998 23:11'!
spawn
	self handleEdit: [textMorph editor spawn].
	self cancel! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 5/10/1998 12:45'!
undo
	textMorph editor undo! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'jm 12/7/2005 09:49'!
yellowButtonActivity
	"Called when the shifted-menu's 'more' item is chosen."

	| menu |
	(menu _ self getMenu: false) ifNotNil: [
		"set up to use perform:orSendTo: for model/view dispatch"
		menu setInvokingView: self.
		menu popUpForHand: self currentWorld activeHand].
! !


!PluggableTextMorph methodsFor: 'updating' stamp: 'dew 6/11/2000 02:21'!
update: aSymbol
	aSymbol ifNil: [^ self].
	aSymbol == #flash ifTrue: [^ self flash].
	aSymbol == getTextSelector ifTrue:
			[self setText: self getText.
			^ self setSelection: self getSelection].
	aSymbol == getSelectionSelector ifTrue: [^ self setSelection: self getSelection].
	(aSymbol == #autoSelect and: [getSelectionSelector ~~ nil]) ifTrue:
			[self handleEdit:
				[textMorph editor setSearch: model autoSelectString;
							againOrSame: true]].
	aSymbol == #clearUserEdits ifTrue: [^ self hasUnacceptedEdits: false].
	aSymbol == #wantToChange ifTrue:
			[self canDiscardEdits ifFalse: [^ self promptForCancel].
			^ self].
	aSymbol == #appendEntry ifTrue:
			[self handleEdit: [self appendEntry].
			^ self refreshWorld].
	aSymbol == #clearText ifTrue:
			[self handleEdit: [self changeText: Text new].
			^ self refreshWorld].
	aSymbol == #bs ifTrue:
			[self handleEdit: [self bsText].
			^ self refreshWorld].
	aSymbol == #codeChangedElsewhere ifTrue:
			[self hasEditingConflicts: true.
			^ self changed]! !


!PluggableTextMorph methodsFor: 'drawing' stamp: 'sw 10/10/1999 23:26'!
drawOn: aCanvas 
	"Include a thin red inset border for unaccepted edits, or, if the unaccepted edits are known to conflict with a change made somewhere else to the same method (typically), put a thick red frame"

	super drawOn: aCanvas. 
	self hasEditingConflicts
		ifTrue:
			[aCanvas frameRectangle: self innerBounds width: 3 color: Color red] 
		ifFalse:
			[self hasUnacceptedEdits ifTrue:
				[aCanvas frameRectangle: self innerBounds width: 1 color: Color red]]! !


!PluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'di 4/20/1998 18:53'!
askBeforeDiscardingEdits: aBoolean
	"Set the flag that determines whether the user should be asked before discarding unaccepted edits."

	askBeforeDiscardingEdits _ aBoolean! !

!PluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'di 4/20/1998 18:52'!
canDiscardEdits
	"Return true if this view either has no text changes or does not care."

	^ (hasUnacceptedEdits & askBeforeDiscardingEdits) not
! !

!PluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'sw 10/10/1999 22:55'!
hasEditingConflicts
	"Return true if a conflicting edit to the same code (typically) is known to have occurred after the current contents started getting edited"

	^ hasEditingConflicts == true! !

!PluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'sw 10/10/1999 22:55'!
hasEditingConflicts: aBoolean

	hasEditingConflicts _ aBoolean! !

!PluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'di 4/20/1998 18:56'!
hasUnacceptedEdits
	"Return true if this view has unaccepted edits."

	^ hasUnacceptedEdits! !

!PluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'sw 10/10/1999 23:06'!
hasUnacceptedEdits: aBoolean
	"Set the hasUnacceptedEdits flag to the given value. "
	aBoolean == hasUnacceptedEdits ifFalse:
		[hasUnacceptedEdits _ aBoolean.
		self changed].
	aBoolean ifFalse: [hasEditingConflicts _ false]! !

!PluggableTextMorph methodsFor: 'unaccepted edits' stamp: 'di 4/21/1998 14:00'!
promptForCancel
	"Ask if it is OK to cancel changes to text"
	(self confirm:
'Changes have not been saved.
Is it OK to cancel those changes?')
		ifTrue: [model clearUserEditFlag].
! !


!PluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 6/22/1998 15:15'!
correctFrom: start to: stop with: aString
	^ self handleEdit: [textMorph editor correctFrom: start to: stop with: aString]! !

!PluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 15:16'!
deselect
	^ textMorph editor deselect! !

!PluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 15:26'!
nextTokenFrom: start direction: dir
	^ textMorph editor nextTokenFrom: start direction: dir! !

!PluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/20/1998 08:32'!
notify: aString at: anInteger in: aStream
	^ textMorph editor notify: aString at: anInteger in: aStream! !

!PluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 14:59'!
select
	^ textMorph editor select! !

!PluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 14:58'!
selectFrom: start to: stop
	^ textMorph editor selectFrom: start to: stop! !

!PluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 15:18'!
selectInvisiblyFrom: start to: stop
	^ textMorph editor selectInvisiblyFrom: start to: stop! !

!PluggableTextMorph methodsFor: 'interactive error protocol' stamp: 'di 5/6/1998 14:56'!
selectionInterval
	^ textMorph editor selectionInterval! !


!PluggableTextMorph methodsFor: 'editor access' stamp: 'di 11/2/1998 15:57'!
handleEdit: editBlock
	| result |
	textMorph editor selectFrom: selectionInterval first to: selectionInterval last;
						model: model.  "For, eg, evaluateSelection"
	textMorph handleEdit: [result _ editBlock value].   "Update selection after edit"
	self scrollSelectionIntoView.
	^ result! !

!PluggableTextMorph methodsFor: 'editor access' stamp: 'di 5/22/1998 12:35'!
scrollSelectionIntoView
	"Scroll my text into view if necessary and return true, else return false"
	^ self scrollSelectionIntoView: nil! !

!PluggableTextMorph methodsFor: 'editor access' stamp: 'ar 11/15/1998 23:45'!
scrollSelectionIntoView: event 
	"Scroll my text into view if necessary and return true, else return false"
	| selRects delta selRect rectToTest transform cpHere |
	selectionInterval _ textMorph editor selectionInterval.
	selRects _ textMorph paragraph selectionRects.
	selRects isEmpty ifTrue: [^ false].
	rectToTest _ selRects first merge: selRects last.
	transform _ scroller transformFrom: self.
	(event notNil and: [event anyButtonPressed]) ifTrue:  "Check for autoscroll"
		[cpHere _ transform localPointToGlobal: event cursorPoint.
		cpHere y <= self top
			ifTrue: [rectToTest _ selRects first topLeft extent: 2@2]
			ifFalse: [cpHere y >= self bottom
					ifTrue: [rectToTest _ selRects last bottomRight extent: 2@2]
					ifFalse: [^ false]]].
	selRect _ transform localBoundsToGlobal: rectToTest.
	selRect height > bounds height
		ifTrue: [^ false].  "Would not fit, even if we tried to scroll"
	(delta _ selRect amountToTranslateWithin: self bounds) y ~= 0 ifTrue:
		["Scroll end of selection into view if necessary"
		self scrollBy: 0@delta y.
		^ true].
	^ false! !


!PluggableTextMorph methodsFor: 'transcript' stamp: 'di 5/13/1998 14:29'!
appendEntry
	"Append the text in the model's writeStream to the editable text. "
	textMorph asText size > model characterLimit ifTrue:
		["Knock off first half of text"
		self selectInvisiblyFrom: 1 to: textMorph asText size // 2.
		self replaceSelectionWith: Text new].
	self selectInvisiblyFrom: textMorph asText size + 1 to: textMorph asText size.
	self replaceSelectionWith: model contents asText.
	self selectInvisiblyFrom: textMorph asText size + 1 to: textMorph asText size! !

!PluggableTextMorph methodsFor: 'transcript' stamp: 'sma 3/15/2000 21:40'!
bsText
	self changeText: (self text copyFrom: 1 to: (self text size - 1 max: 0))! !

!PluggableTextMorph methodsFor: 'transcript' stamp: 'di 5/8/1998 21:22'!
changeText: aText
	"The paragraph to be edited is changed to aText."
	self setText: aText! !

!PluggableTextMorph methodsFor: 'transcript' stamp: 'di 5/9/1998 21:40'!
replaceSelectionWith: aText
	^ textMorph editor replaceSelectionWith: aText! !


!PluggableTextMorph methodsFor: 'pane events' stamp: 'tk 4/5/1999 03:12'!
mouseEnter: event
	super mouseEnter: event.
	selectionInterval ifNotNil:
		[textMorph handleEdit: [textMorph editor selectInterval: selectionInterval.
			textMorph editor setEmphasisHere]].
	event hand newKeyboardFocus: textMorph! !

!PluggableTextMorph methodsFor: 'pane events' stamp: 'jm
 8/20/1998 08:39'!
mouseLeave: event

	textMorph ifNotNil: [selectionInterval _ textMorph editor selectionInterval].
	super mouseLeave: event.
	event hand newKeyboardFocus: nil.
! !


!PluggableTextMorph methodsFor: 'geometry' stamp: 'kfr 6/8/2000 22:38'!
resetExtent
	"Reset the extent while maintaining the current selection.  Needed when resizing while the editor is active (when inside the pane)."
	| tempSelection |
	textMorph notNil ifTrue:
		["the current selection gets munged by resetting the extent, so store it"
		tempSelection _ self selectionInterval.
		
		"don't reset it if it's not active"
		tempSelection = (Interval from: 1 to: 0) 
						ifTrue: [retractableScrollBar
							ifTrue:[ ^ self]].
		self extent: self extent.
		self setSelection: tempSelection]! !

!PluggableTextMorph methodsFor: 'geometry' stamp: 'dew 2/19/1999 17:08'!
scrollDeltaHeight
	"Return the increment in pixels which this pane should be scrolled."
	^ scroller firstSubmorph defaultLineHeight
! !


!PluggableTextMorph methodsFor: 'accessing' stamp: 'sr 4/25/2000 07:21'!
getTextSelector
	^getTextSelector! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PluggableTextMorph class
	instanceVariableNames: ''!

!PluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'di 4/7/98 16:03'!
on: anObject text: getTextSel accept: setTextSel

	^ self on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: nil
		menu: nil! !

!PluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'di 4/7/98 16:03'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel

	^ self new on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !
