MultiArgCommandBlockMorph subclass: #VariableDeclarationBlockMorph
	instanceVariableNames: 'varNameMap '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!
!VariableDeclarationBlockMorph commentStamp: '<historical>' prior: 0!
VariableDeclarationBlockMorph new commandSpec: 'local variables'; color: ScratchFrameMorph palettePaneColor; openInWorld
!


!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:33'!
addItem
	| varBlock pos vname names |
	names _ #(a b c d e f g h i j k l m n o p q r s t u v w x y z foo bar baz).
	super addItem.
	pos _ argMorphs size.
	pos > names size
		ifTrue: [vname _ ('z', (pos - names size + 1) printString) asUTF8]
		ifFalse: [vname _ (names at: pos) asString asUTF8].
	varBlock _ VariableBlockMorph new.
	varBlock 
		isSpecialForm: true;
		selector: #getVar:;
"		color: (ScriptableScratchMorph blockColorFor: 'variables');"
		commandSpec: vname.
	self replaceArgMorph: (self argumentAt: pos) by: varBlock.! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2010 02:47'!
args
	^argMorphs! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/25/2010 19:59'!
defaultArgs: anArray
 	"override my superclass, do nothing"! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 22:08'!
deleteVariableTemplate: aVarBlockMorph

	aVarBlockMorph delete.
	argMorphs remove: aVarBlockMorph.
	self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3)! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2010 02:43'!
isPartsBin
	^true! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/17/2010 00:51'!
removeItem
	argMorphs size > self minArgs ifTrue: [
		self removeLastArg.
		self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3) ]! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/26/2010 20:54'!
removeLastArg

	| idx |
	idx _ argMorphs size.
	(argMorphs at: idx) delete.
	argMorphs at: idx put: nil.
! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/26/2010 21:01'!
renameParm: old to: new

	(self variables includes: new) ifTrue: [
		DialogBoxMorph warn: 'This variable name already exists'.
		^false ].
	^true! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/26/2010 21:01'!
rootForGrabOf: aMorph

	| root |
	root _ aMorph.
	[root = self] whileFalse: [
		root owner == self ifTrue: [
			self isPartsBin ifTrue: [
				root = self nextBlock
					ifTrue: [^root]
					ifFalse: [^ root fullCopy]].
			self dragNDropEnabled ifTrue: [^ root]].
		root _ root owner].

	^ super rootForGrabOf: aMorph
! !

!VariableDeclarationBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/26/2010 20:56'!
variables
	^argMorphs collect: [:a |
		a variable ]! !


!VariableDeclarationBlockMorph methodsFor: 'Enchanting' stamp: 'JM 10/12/2011 15:20'!
createShortNamesForScriptVariables: aNumber

	"Creates a map of names for the script variables in this block. The given number will be used as the first in the sequence for this block, and ensures that names are unique when multiple script variable blocks appear in one script."

	| shortName index |

	varNameMap _ Dictionary new.

	index _ aNumber.
	self variables asSortedCollection do: [ :name |
		shortName _ 'script_var' , index asString.
		varNameMap at: name put: shortName.
		index _ index + 1.
	].

	^ super createShortNamesForScriptVariables: index
	! !

!VariableDeclarationBlockMorph methodsFor: 'Enchanting' stamp: 'JM 12/6/2011 11:38'!
exportCodeWith: anExporter
	
	"If this declaration is part of a custom block, we ignore it as the declarations will have been exported as instance variables (necessary because Java doesn't support closures). If this declaration is part of a script, we export them now. --- EDIT - for now, we're exporting all script variables as instance vars"

	anExporter exportScriptVarsFor: self.
	self nextBlock ifNotNil: [self nextBlock exportCodeWith: anExporter].! !

!VariableDeclarationBlockMorph methodsFor: 'Enchanting' stamp: 'JM 12/5/2011 12:54'!
scriptVarShortNames

	"returns the script variable short names declared by this block and any subssequent blocks"
	| names |
	names _ varNameMap.
	super scriptVarShortNames associationsDo: [ :assoc | names at: assoc key put: assoc value ].
	^ names! !
