#!/usr/bin/env python

"""This script downloads and extracts the image file needed for Enchanting development.

Python was chosen as windows doesn't have a built-in equivalent to cURL or wget,
and, as bzr is being used for source control, you've already got python installed."""

source = "http://static.robotclub.ab.ca/source_code/enchanting/Enchanting-Image-Latest.zip"

# Downloads files needed for Enchanting development
import urllib
import os
import sys
import zipfile

progressBarDisplayed = 0
displayWidth = 75

def downloadReportHook(count, blockSize, totalSize):
	global progressBarDisplayed
	global displayWidth
	amountDownloaded = count * blockSize	# in bytes
	progress = int(displayWidth * amountDownloaded / totalSize)
	if amountDownloaded == 0:
		progressBarDisplayed = 0
	if progress > progressBarDisplayed:
		sys.stdout.write('=' * (progress - progressBarDisplayed),)
		progressBarDisplayed = progress
	
def getFilename(url):
	"""Returns the filename specified in the URL (everything right of the trailing slash)"""
	return url[ url.rfind('/') + 1 : ]
	

def downloadFile(url):
	global displayWidth
	print "Downloading %s" % (url)
	print '|' + '-' * (displayWidth - 2) + '|'
	urllib.urlretrieve(url, getFilename(url), downloadReportHook)
	print
	print
	

def unzipFile(file):
	"""Note that ths is not a general purpose unzipping routine!"""
	zfobj = zipfile.ZipFile(file)
	for name in zfobj.namelist():
		outfile = open(name, 'wb')
		outfile.write(zfobj.read(name))
		outfile.close()

# +++++++++++++++++++++++
# + Program starts here +
	
# Open stdout in unbuffered mode (for our progress bar)
sys.stdout = os.fdopen(sys.stdout.fileno(), 'w', 0)

downloadFile(source)

print "Extracting the image."
unzipFile(getFilename(source))

# Delete the downloaded file
os.remove(getFilename(source))

print
print "You now have the latest Enchanting image."
